<template>
  <div class="cart">
    <div class="container">
      <h1 class="section-title">Моя корзина</h1>
      <router-link to="/products">
        <div class="cart__btn-down">Вернуться к каталогу</div>
      </router-link>
      <div class="cart-items">
        <p class="cart-items__text" v-if="!CART.length">Корзина пуста, добавьте товар в каталоге</p>
        <CartItem v-for="(item, index) in CART" :key="index" :cart_data_item="item" @deleteProduct="deleteProduct(index)"
          @increment="increment(index)" @decrement="decrement(index)" />
      </div>
    </div>
    <div class="cart__sum-products">
      <div class="cart__sum-products-text">К оплате:</div>
      <div class="cart__sum-products-price">{{ sumProducts }} <span>руб.</span> </div>
    </div>
  </div>
</template>


<script>
import CartItem from '../cart/Cart-item.vue';
import { mapGetters, mapActions } from 'vuex';

export default {
  name: 'cart',
  components: {
    CartItem
  },
  props: {
    cart_data: {
      type: Array,
      default() {
        return []
      }
    }
  },
  methods: {
    ...mapActions([
      'DELETE_TO_CART',
      'INCREMENT_PRODUCT',
      'DECREMENT_PRODUCT',
    ]),
    deleteProduct(index) {
      this.DELETE_TO_CART(index)
    },
    increment(index) {
      this.INCREMENT_PRODUCT(index)
    },
    decrement(index) {
      this.DECREMENT_PRODUCT(index)
    }
  },
  computed: {
    ...mapGetters([
      'CART'
    ]),
    sumProducts() {
      let result = [];

      if (!this.CART.length) {
        return result = 0;
      } else {
        for (let item of this.CART) {
          result.push(item.price * item.quantity)
        }

        result = result.reduce((sum, el) => {
          return sum + el
        })
        return result
      }
    }
  }
}

</script>


<style lang="scss">
.cart-items {
  display: flex;
  flex-wrap: wrap;

  &__text {
    margin: 150px auto;
  }

}

.cart {
  padding: 64px 0 90px;

  a {
    text-decoration: none;
    position: relative;
    top: -76px;
    left: 0;
  }

  &__btn-down {
    color: rgb(140, 140, 248);
  }

  &__sum-products {
    position: fixed;
    bottom: 0;
    right: 0;
    left: 0;
    background: #fff4c7;
    height: 90px;
    padding: 18px 60px;
    display: flex;
    justify-content: space-between;
    align-items: center;
    color: black;
    font-size: 20px;
    gap: 10px;
  }
}
</style>